﻿using System.Diagnostics;
using BlockMania.GeneralStates.Screen_02_Play;
using BlockMania.GeneralStates.Screen_03_Settings;
using BlockMania.GeneralStates.Screen_04_Help;
using BlockMania.Global;
using BlockMania.Util;

namespace BlockMania.GeneralStates.Screen_01_Home
{
	internal static class Transition
	{
		private static int transitionStep = TRANSITION_STEP_MIN;
		private static readonly Delay delay = new Delay(75);

		private const int TRANSITION_STEP_MIN = 0;
		private const int TRANSITION_STEP_MAX = 10;

		private const int LAMEL_AANTAL = 12;
		private const int LAMEL_HOOGTE = GlobalData.PANEL_HEIGHT / LAMEL_AANTAL;
		private const int LAMEL_GROW_SIZE = LAMEL_HOOGTE / TRANSITION_STEP_MAX;

		internal static void TriggerPartOne()
		{
			DrawTransitionBlinds();

			if (delay.HasExpired())
			{
				transitionStep++;
			}

			if (transitionStep > TRANSITION_STEP_MAX)
			{
				Screen_1_Home.SwitchToNormalState();
				GlobalController.SwitchToPlay();
			}
		}

		internal static void TriggerPartTwo()
		{
			DrawTransitionBlinds();

			if (delay.HasExpired())
			{
				transitionStep--;
			}

			if (transitionStep < TRANSITION_STEP_MIN)
			{
				Screen_2_Play.SwitchToNormalState();
				Screen_3_Settings.SwitchToNormalState();
				Screen_4_Help.SwitchToNormalState();
			}
		}

		private static void DrawTransitionBlinds()
		{
			int lamelHeight = LAMEL_GROW_SIZE * transitionStep;

			for (int i = 0 ; i <= LAMEL_AANTAL ; i++)
			{
				const int X = 0;
				int y = i * LAMEL_HOOGTE;
				GlobalCanvas.canvas.FillRectangle(
					GlobalColors.BRUSH_TRANSITION_BLINDS, X, y,
					GlobalData.PANEL_WIDTH, lamelHeight);
			}
		}

	}
}