﻿using System.Collections.Generic;
using BlockMania.Global;
using BlockMania.View;

namespace BlockMania.GeneralStates.Screen_02_Play
{
	internal static class RowRemover
	{
		internal static void RemoveRows(List<int> rows)
		{
			// For this to work correctly,
			// the row-numbers in list 'rows' must be sorted from top to bottom.

			foreach (int row in rows)
			{
				RemoveRow(row);
			}

			ScoreManager.AddRows(rows.Count);
		}

		private static void RemoveRow(int rowTarget)
		{
			while (rowTarget > 0)
			{
				int rowToPullDown = rowTarget - 1;

				for (int col = 0; col < GlobalData.COL_COUNT ; col++)
				{
					Gamefield.grid[rowTarget, col] = Gamefield.grid[rowToPullDown, col];
					Gamefield.grid[rowToPullDown, col] = 0;
				}

				rowTarget--;
			}
		}

	}
}