﻿using System.Drawing;
using BlockMania.Global;
using BlockMania.Util;

namespace BlockMania.GeneralStates.Screen_02_Play
{
	internal static class State_03_Paused
	{
		private static TextBlinking text01;
		private static TextBlinking text02;
		private static TextBlinking text03;
		private static TextBlinking text04;

		private const int SPACER = 60;

		private static int width;
		private static int height;

		internal static void Init()
		{
			string text = "press";
			Font font = FontManager.font_65;
			int Y = 205;
			int X = Tools.CalculateXforStringOnGamefield(text, font);
			text01 = new TextBlinking(text, font, GlobalColors.BRUSH_WHITE, 1000, X, Y);

			text = "'ESC'";
			Y = text01.y + SPACER;
			X = Tools.CalculateXforStringOnGamefield(text, font);
			text02 = new TextBlinking(text, font, GlobalColors.BRUSH_YELLOW, 1000, X, Y);

			text = "to";
			Y = text02.y + SPACER;
			X = Tools.CalculateXforStringOnGamefield(text, font);
			text03 = new TextBlinking(text, font, GlobalColors.BRUSH_WHITE, 1000, X, Y);

			text = "continue";
			Y = text03.y + SPACER;
			X = Tools.CalculateXforStringOnGamefield(text, font);
			text04 = new TextBlinking(text, font, GlobalColors.BRUSH_WHITE, 1000, X, Y);

			SizeF stringSize = Tools.GetStringSize(text, font);
			width  = (int) (stringSize.Width + 20);
			height = (int) ((stringSize.Height * 3) + 65);
		}

		internal static void Reset()
		{
			text01.Reset();
			text02.Reset();
			text03.Reset();
			text04.Reset();
		}

		internal static void HandleGameTick()
		{
			Draw();
		}

		private static void Draw()
		{
			if (text01.toggle) // Synchronize with the blinking-rate of the text.
			{
				Tools.DrawRectangleWithBorderAndFill(
					text01.x - 55, text01.y - 10,
					width, height,
					GlobalData.GAME_FIELD_BORDER_WIDTH,
					GlobalColors.GAME_FIELD_BORDER_COLOR,
					GlobalColors.BRUSH_RED
				);
			}

			text01.HandleGameTick();
			text02.HandleGameTick();
			text03.HandleGameTick();
			text04.HandleGameTick();
		}

		// Dit is de enige 'state' die geen eigen 'HandleInput' heeft.
		// De reden hiervoor is dat deze state [actief] gemaakt wordt met 'Esc',
		// maar dat deze state ook [gestopt] moet kunnen worden met 'Esc'.

		// Want; je klikt op 'Esc' als je de game wilt pauzeren en
		// je klikt nogmaals op 'Esc' als je weer verder wilt spelen.

		// Deze 'Esc' wordt afgevangen in Screen_2_Play.HandleInput

	}
}