﻿namespace BlockMania.Global
{
	internal static class GlobalData
	{
		internal const string WINDOW_TITLE = "BlockMania";

		internal const int PANEL_WIDTH  = 995;
		internal const int PANEL_HEIGHT = 780;

		internal const int WINDOW_WIDTH  = (PANEL_WIDTH  + 20);
		internal const int WINDOW_HEIGHT = (PANEL_HEIGHT + 20);

		//---

		internal const int ROW_COUNT = 20;
		internal const int COL_COUNT = 10;

		internal const int COL_MIN = 0;
		internal const int COL_MAX = (COL_COUNT - 1);

		internal const int ROW_MIN = 0;
		internal const int ROW_MAX = (ROW_COUNT - 1);

		//---

		internal const int TILE_WIDTH  = 45;
		internal const int TILE_HEIGHT = 35;

		//---

		internal const int GAME_FIELD_WIDTH  = (COL_COUNT * TILE_WIDTH);
		internal const int GAME_FIELD_HEIGHT = (ROW_COUNT * TILE_HEIGHT);

		internal const int GAME_FIELD_LOCATION_X = 25;
		internal const int GAME_FIELD_LOCATION_Y = 30;

		internal const int GAME_FIELD_BORDER_WIDTH = 2;

		//---

		internal const int PREVIEW_TILE_WIDTH  = 35;
		internal const int PREVIEW_TILE_HEIGHT = 25;

		internal const int PREVIEW_FIELD_WIDTH  = (PREVIEW_TILE_WIDTH  * 5);
		internal const int PREVIEW_FIELD_HEIGHT = (PREVIEW_TILE_HEIGHT * 4);

		internal const int PREVIEW_FIELD_LOCATION_X = (GAME_FIELD_LOCATION_X + GAME_FIELD_WIDTH + 130);
		internal const int PREVIEW_FIELD_LOCATION_Y = (GAME_FIELD_LOCATION_Y + 80);

		//---

		internal const int SCORE_LOCATION_X = (PREVIEW_FIELD_LOCATION_X - 30);
		internal const int SCORE_LOCATION_Y = (PREVIEW_FIELD_LOCATION_Y + PREVIEW_FIELD_HEIGHT + 60);

		internal const int LEVEL_UP_THRESHOLD = 10; // Do level-up every time this number of rows have been cleared.

	}
}