﻿using System.Collections.Generic;

namespace BlockMania.Util
{
	internal class Block
	{
		// This is the Block on the game-field that is controlled by the player.

		internal int number;
		internal int colorCode;

		internal List<List<int>> matrix;

		internal readonly List<Tile> tiles  = new List<Tile>();
		internal readonly Offset     offset = new Offset(0, 0);

		internal int heightInTiles;
		internal int widthInTiles;

		internal int heightInPixels;
		internal int widthInPixels;

		internal Block(int number)
		{
			this.number = number;
			colorCode   = number + 1;
		}

		internal void IncrementRowOffset()
		{
			offset.row++;
		}

		internal void IncrementColOffset()
		{
			offset.col++;
		}

		internal void DecrementRowOffset()
		{
			offset.row--;
		}

		internal void DecrementColOffset()
		{
			offset.col--;
		}

	}
}