﻿using BlockMania.View;

namespace BlockMania.Util.BlockTools
{
	internal static class BlockFlipTool
	{
		internal static void Flip(Block block)
		{
			int blockSize = block.matrix[0].Count;
			switch (blockSize)
			{
				case 3:	flip_3x3(block, 3) ; break;
				case 4: flip_4x4(block, 4) ; break;
			}
		}

		private static void flip_3x3(Block block, int range)
		{
			for (int row = 0 ; row < range ; row++)
			{
				block.matrix[row][0] = Gamefield.GetBlock().matrix[row][2];
				block.matrix[row][1] = Gamefield.GetBlock().matrix[row][1];
				block.matrix[row][2] = Gamefield.GetBlock().matrix[row][0];
			}
		}

		private static void flip_4x4(Block block, int range)
		{
			for (int row = 0 ; row <= range ; row++)
			{
				for (int col = 0 ; col <= range ; col++)
				{
					block.matrix[row][col] = Gamefield.GetBlock().matrix[row][range - col - 1];
				}
			}
		}

	}
}