﻿using System.Collections.Generic;
using BlockMania.GeneralStates.Screen_03_Settings;

namespace BlockMania.Util.BlockTools
{
	internal static class MatrixTool
	{
		private static List<List<int>> matrix_O = new List<List<int>>
		{
			new List<int> { 1, 1 },
			new List<int> { 1, 1 }
		};

		private static List<List<int>> matrix_S = new List<List<int>>
		{
			new List<int> { 0, 0, 0 },
			new List<int> { 0, 1, 1 },
			new List<int> { 1, 1, 0 }
		};

		private static List<List<int>> matrix_Z =  new List<List<int>>
		{
			new List<int> { 0, 0, 0 },
			new List<int> { 1, 1, 0 },
			new List<int> { 0, 1, 1 }
		};

		private static List<List<int>> matrix_L = new List<List<int>>
		{
			new List<int> { 0, 0, 0 },
			new List<int> { 1, 1, 1 },
			new List<int> { 1, 0, 0 }
		};

		private static List<List<int>> matrix_J = new List<List<int>>
		{
			new List<int> { 0, 0, 0 },
			new List<int> { 1, 1, 1 },
			new List<int> { 0, 0, 1 }
		};

		private static List<List<int>> matrix_T = new List<List<int>>
		{
			new List<int> { 0, 0, 0 },
			new List<int> { 1, 1, 1 },
			new List<int> { 0, 1, 0 }
		};

		private static List<List<int>> matrix_I = new List<List<int>>
		{
			new List<int> { 0, 0, 0, 0 },
			new List<int> { 1, 1, 1, 1 },
			new List<int> { 0, 0, 0, 0 },
			new List<int> { 0, 0, 0, 0 }
		};

		private static List<List<int>> matrix_01 = new List<List<int>>
		{
			new List<int> { 1, 1, 1 },
			new List<int> { 0, 1, 1 },
			new List<int> { 0, 0, 0 }
		};

		private static List<List<int>> matrix_03 = new List<List<int>>
		{
			new List<int> { 0, 1, 0 },
			new List<int> { 1, 1, 1 },
			new List<int> { 0, 1, 1 }
		};

		private static List<List<int>> matrix_04 = new List<List<int>>
		{
			new List<int> { 1, 0, 0 },
			new List<int> { 1, 1, 1 },
			new List<int> { 0, 1, 1 }
		};

		private static List<List<int>> matrix_09 = new List<List<int>>
		{
			new List<int> { 0, 0, 1 },
			new List<int> { 1, 1, 1 },
			new List<int> { 1, 0, 0 }
		};

		private static List<List<int>> matrix_02 = new List<List<int>>
		{
			new List<int> { 1, 1, 1 },
			new List<int> { 0, 1, 1 },
			new List<int> { 0, 0, 1 }
		};

		private static List<List<int>> matrix_05 = new List<List<int>>
		{
			new List<int> { 1, 0, 0 },
			new List<int> { 1, 1, 1 },
			new List<int> { 0, 1, 0 }
		};

		private static List<List<int>> matrix_06 = new List<List<int>>
		{
			new List<int> { 0, 1, 1 },
			new List<int> { 1, 1, 0 },
			new List<int> { 1, 0, 0 }
		};

		private static List<List<int>> matrix_07 = new List<List<int>>
		{
			new List<int> { 1, 1, 1 },
			new List<int> { 0, 1, 0 },
			new List<int> { 0, 1, 0 }
		};

		private static List<List<int>> matrix_08 = new List<List<int>>
		{
			new List<int> { 1, 1, 1 },
			new List<int> { 1, 0, 1 },
			new List<int> { 0, 0, 0 }
		};

		private static List<List<int>> matrix_10 = new List<List<int>>
		{
			new List<int> { 0, 1, 0 },
			new List<int> { 1, 1, 1 },
			new List<int> { 0, 1, 0 }
		};

		private static List<List<int>> matrix_11 = new List<List<int>>
		{
			new List<int> { 1, 1, 1 },
			new List<int> { 1, 0, 1 },
			new List<int> { 0, 0, 1 }
		};

		private static readonly List<List<int>>[] matrixPool =
		{
			matrix_O, matrix_S, matrix_Z, matrix_L, matrix_J, matrix_T, matrix_I,
			matrix_01, matrix_03, matrix_04
		};

		internal static int GetBlockPoolSize()
		{
			if (SettingStorage.extraBlocks)
			{
				return matrixPool.Length;
			}
			else
			{
				return matrixPool.Length - 3;
			}
		}

		internal static int GetRandomBlockNumber()
		{
			return Tools.GetRandomNumber(GetBlockPoolSize());
		}

		internal static void SetMatrix(Block block)
		{
			List<List<int>> matrix = matrixPool[block.number];
			block.matrix = Tools.Copy_2d_List(matrix);
		}

	}
}