﻿using System.Collections.Generic;
using BlockMania.Global;
using BlockMania.View;

namespace BlockMania.Util.BlockTools
{
	internal static class RowCheckTool
	{
		internal static readonly List<int> clearedRows = new List<int>();

		internal static bool HasGamefieldClearedRows()
		{
			clearedRows.Clear();

			for (int row = 0; row < GlobalData.ROW_COUNT; row++)
			{
				if (Gamefield.IsLocationOccupied(row, GlobalData.COL_MIN) &&
				    Gamefield.IsLocationOccupied(row, GlobalData.COL_MAX))
				{
					if (IsRowCleared(row))
					{
						clearedRows.Add(row);
					}
				}
			}

			return (clearedRows.Count > 0);
		}

		private static bool IsRowCleared(int row)
		{
			bool isRowCleared = true;

			for (int col = 0; col < GlobalData.COL_COUNT ; col++)
			{
				if (! Gamefield.IsLocationOccupied(row, col))
				{
					isRowCleared = false;
					break;
				}
			}

			return isRowCleared;
		}

	}
}