using System;

namespace BlockMania.Util
{
	internal class Delay
	{
		private DateTime startTime;
		private TimeSpan timeToPause;

		public Delay(double millisecondsToPause)
		{
			SetTimeToPause(millisecondsToPause);
		}

		internal void SetTimeToPause(double millisecondsToPause)
		{
			timeToPause = TimeSpan.FromMilliseconds(millisecondsToPause);
			Reset();
		}

		internal bool HasExpired()
		{
			TimeSpan elapsedTime = DateTime.Now - startTime;
			if (elapsedTime >= timeToPause)
			{
				Reset();
				return true;
			}

			return false;
		}

		internal bool IsPausing()
		{
			return !HasExpired();
		}

		internal void Reset()
		{
			startTime = DateTime.Now;
		}
	}
}