﻿using System;
using System.Runtime.InteropServices;
using BlockMania.Util.PrecisionTiming.Base;

namespace BlockMania.Util.PrecisionTiming.Multimedia
{
	internal static class MMTimerExports
	{
		[DllImport(Constants.windowsMultimediaAPIString)]
		internal static extern int timeBeginPeriod(int period);

		[DllImport(Constants.windowsMultimediaAPIString)]
		internal static extern int timeEndPeriod(int period);

		[DllImport(Constants.windowsMultimediaAPIString)]
		internal static extern int timeGetDevCaps(ref TimerCapabilities caps, int sizeOfTimerCaps);

		[DllImport(Constants.windowsMultimediaAPIString)]
		internal static extern int timeKillEvent(int id);

		[DllImport(Constants.windowsMultimediaAPIString)]
		internal static extern int timeSetEvent(int delay, int resolution, TimerProc proc, IntPtr user, TimerMode mode);

		internal delegate void TimerProc(int hwnd, int uMsg, IntPtr idEvent, int dwTime, int WTFref);

		internal static TimerCapabilities Capabilities;
	}
}