﻿using System.Diagnostics;
using System.IO;
using System.Linq;
using System.Reflection;
using System.Windows.Forms;

namespace BlockMania.Util
{
	internal static class ResourceLocator
	{
		private static readonly Assembly ThisExe = Assembly.GetExecutingAssembly();

		internal static string pathAndFileNameForSettings;
		// internal static string pathForSavingReplays;

		internal static void Init()
		{
			string path = Application.StartupPath;
			pathAndFileNameForSettings = path + @"\settings.txt";
			// pathForSavingReplays = path + @"\my_resources\replays_saved\";

			// ShowEmbeddedResources();
		}

		internal static void ShowEmbeddedResources()
		{
			Debug.WriteLine("--- Embedded resources :");
			string[] resources = ThisExe.GetManifestResourceNames();
			foreach (string resource in resources) Debug.WriteLine(resource);
			Debug.WriteLine("---");
		}

		internal static Stream GetResourceStream(string resourceName)
		{
			string resourcePath = ThisExe.GetManifestResourceNames().Single(str => str.EndsWith(resourceName));
			return ThisExe.GetManifestResourceStream(resourcePath);
		}

	}
}