﻿using System.Drawing;
using BlockMania.Global;

namespace BlockMania.Util
{
	internal class TextBlinking
	{
		private readonly Delay pauseAnimation = new Delay(140);

		private readonly string text;

		private readonly Brush brush;
		private readonly Font font;

		internal readonly int x;
		internal readonly int y;

		internal bool toggle;

		internal TextBlinking(string text, Font font, Brush brush, long blinkRate, int x, int y)
		{
			this.text = text;

			this.font = font;
			this.brush = brush;

			pauseAnimation.SetTimeToPause(blinkRate);

			this.x = x;
			this.y = y;
		}

		internal void Reset()
		{
			pauseAnimation.Reset();
			toggle = true;
		}

		internal void HandleGameTick()
		{
			DrawText();
			if (pauseAnimation.HasExpired())
			{
				toggle = !toggle;
			}
		}

		private void DrawText()
		{
			if (toggle)
			{
				GlobalCanvas.canvas.DrawString(text, font, brush, x, y);
			}
		}

	}
}