﻿using System.Drawing;
using BlockMania.Global;

namespace BlockMania.Util
{
	internal class TextStatic
	{
		internal string text;

		private readonly Font  font;
		private readonly Brush brush;

		internal readonly int x;
		internal readonly int y;

		internal TextStatic(string text, Font font, Brush brush, int x, int y)
		{
			this.text = text;

			this.font = font;
			this.brush = brush;

			this.x = x;
			this.y = y;
		}

		internal void HandleGameTick()
		{
			DrawText();
		}

		private void DrawText()
		{
			GlobalCanvas.canvas.DrawString(text, font, brush, x, y);
		}
	}

}